Index: uspace/app/sbi/src/parse.c
===================================================================
--- uspace/app/sbi/src/parse.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/parse.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -35,4 +35,5 @@
 #include <assert.h>
 #include <stdlib.h>
+#include "cspan.h"
 #include "debug.h"
 #include "lex.h"
@@ -64,4 +65,5 @@
 static stree_prop_t *parse_prop(parse_t *parse, stree_csi_t *outer_csi);
 
+static void parse_symbol_attrs(parse_t *parse, stree_symbol_t *symbol);
 static stree_symbol_attr_t *parse_symbol_attr(parse_t *parse);
 
@@ -70,4 +72,6 @@
 static stree_fun_sig_t *parse_fun_sig(parse_t *parse);
 
+static void parse_prop_get(parse_t *parse, stree_prop_t *prop);
+static void parse_prop_set(parse_t *parse, stree_prop_t *prop);
 
 /*
@@ -175,4 +179,5 @@
 	stree_ident_t *targ_name;
 	stree_targ_t *targ;
+	stree_texpr_t *pref;
 
 	switch (dclass) {
@@ -212,7 +217,16 @@
 		/* Inheritance list */
 		lskip(parse);
-		csi->base_csi_ref = parse_texpr(parse);
-	} else {
-		csi->base_csi_ref = NULL;
+
+		while (b_true) {
+			pref = parse_texpr(parse);
+			if (parse_is_error(parse))
+				break;
+
+			list_append(&csi->inherit, pref);
+			if (lcur_lc(parse) != lc_plus)
+				break;
+
+			lskip(parse);
+		}
 	}
 
@@ -224,10 +238,24 @@
 		csimbr = parse_csimbr(parse, csi);
 		if (csimbr == NULL)
+			continue;
+
+		list_append(&csi->members, csimbr);
+	}
+
+	lmatch(parse, lc_end);
+
+	if (outer_csi != NULL) {
+		switch (outer_csi->cc) {
+		case csi_class:
+		case csi_struct:
 			break;
-
-		list_append(&csi->members, csimbr);
-	}
-
-	lmatch(parse, lc_end);
+		case csi_interface:
+			cspan_print(csi->name->cspan);
+			printf(" Error: CSI declared inside interface.\n");
+			parse_note_error(parse);
+			/* XXX Free csi */
+			return NULL;
+		}
+	}
 
 	return csi;
@@ -253,4 +281,6 @@
 	stree_prop_t *prop;
 
+	csimbr = NULL;
+
 	switch (lcur_lc(parse)) {
 	case lc_class:
@@ -258,21 +288,29 @@
 	case lc_interface:
 		csi = parse_csi(parse, lcur_lc(parse), outer_csi);
-		csimbr = stree_csimbr_new(csimbr_csi);
-		csimbr->u.csi = csi;
+		if (csi != NULL) {
+			csimbr = stree_csimbr_new(csimbr_csi);
+			csimbr->u.csi = csi;
+		}
 		break;
 	case lc_new:
 		ctor = parse_ctor(parse, outer_csi);
-		csimbr = stree_csimbr_new(csimbr_ctor);
-		csimbr->u.ctor = ctor;
+		if (ctor != NULL) {
+			csimbr = stree_csimbr_new(csimbr_ctor);
+			csimbr->u.ctor = ctor;
+		}
 		break;
 	case lc_deleg:
 		deleg = parse_deleg(parse, outer_csi);
-		csimbr = stree_csimbr_new(csimbr_deleg);
-		csimbr->u.deleg = deleg;
+		if (deleg != NULL) {
+			csimbr = stree_csimbr_new(csimbr_deleg);
+			csimbr->u.deleg = deleg;
+		}
 		break;
 	case lc_enum:
 		enum_d = parse_enum(parse, outer_csi);
-		csimbr = stree_csimbr_new(csimbr_enum);
-		csimbr->u.enum_d = enum_d;
+		if (enum_d != NULL) {
+			csimbr = stree_csimbr_new(csimbr_enum);
+			csimbr->u.enum_d = enum_d;
+		}
 		break;
 	case lc_fun:
@@ -283,6 +321,8 @@
 	case lc_var:
 		var = parse_var(parse, outer_csi);
-		csimbr = stree_csimbr_new(csimbr_var);
-		csimbr->u.var = var;
+		if (var != NULL) {
+			csimbr = stree_csimbr_new(csimbr_var);
+			csimbr->u.var = var;
+		}
 		break;
 	case lc_prop:
@@ -294,5 +334,4 @@
 		lunexpected_error(parse);
 		lex_next(parse->lex);
-		csimbr = NULL;
 		break;
 	}
@@ -311,5 +350,5 @@
 	stree_ctor_t *ctor;
 	stree_symbol_t *symbol;
-	stree_symbol_attr_t *attr;
+	cspan_t *cspan;
 
 	ctor = stree_ctor_new();
@@ -321,4 +360,5 @@
 
 	lmatch(parse, lc_new);
+	cspan = lprev_span(parse);
 
 	/* Fake identifier. */
@@ -334,5 +374,6 @@
 	ctor->sig = parse_fun_sig(parse);
 	if (ctor->sig->rtype != NULL) {
-		printf("Error: Constructor of CSI '");
+		cspan_print(cspan);
+		printf(" Error: Constructor of CSI '");
 		symbol_print_fqn(csi_to_symbol(outer_csi));
 		printf("' has a return type.\n");
@@ -340,12 +381,6 @@
 	}
 
-	list_init(&symbol->attr);
-
 	/* Parse attributes. */
-	while (lcur_lc(parse) == lc_comma && !parse_is_error(parse)) {
-		lskip(parse);
-		attr = parse_symbol_attr(parse);
-		list_append(&symbol->attr, attr);
-	}
+	parse_symbol_attrs(parse, symbol);
 
 	ctor->proc = stree_proc_new();
@@ -356,5 +391,6 @@
 
 		/* This constructor has no body. */
-		printf("Error: Constructor of CSI '");
+		cspan_print(cspan);
+		printf(" Error: Constructor of CSI '");
 		symbol_print_fqn(csi_to_symbol(outer_csi));
 		printf("' has no body.\n");
@@ -368,4 +404,16 @@
 	}
 
+	switch (outer_csi->cc) {
+	case csi_class:
+	case csi_struct:
+		break;
+	case csi_interface:
+		cspan_print(ctor->name->cspan);
+		printf(" Error: Constructor declared inside interface.\n");
+		parse_note_error(parse);
+		/* XXX Free ctor */
+		return NULL;
+	}
+
 	return ctor;
 }
@@ -409,4 +457,5 @@
 
 	if (list_is_empty(&enum_d->members)) {
+		cspan_print(enum_d->name->cspan);
 		printf("Error: Enum type '%s' has no members.\n",
 		    strtab_get_str(enum_d->name->sid));
@@ -416,4 +465,18 @@
 	lmatch(parse, lc_end);
 
+	if (outer_csi != NULL) {
+		switch (outer_csi->cc) {
+		case csi_class:
+		case csi_struct:
+			break;
+		case csi_interface:
+			cspan_print(enum_d->name->cspan);
+			printf(" Error: Enum declared inside interface.\n");
+			parse_note_error(parse);
+			/* XXX Free enum */
+			return NULL;
+		}
+	}
+
 	return enum_d;
 }
@@ -449,5 +512,4 @@
 	stree_deleg_t *deleg;
 	stree_symbol_t *symbol;
-	stree_symbol_attr_t *attr;
 
 	deleg = stree_deleg_new();
@@ -467,14 +529,20 @@
 	deleg->sig = parse_fun_sig(parse);
 
-	list_init(&symbol->attr);
-
 	/* Parse attributes. */
-	while (lcur_lc(parse) == lc_comma && !parse_is_error(parse)) {
-		lskip(parse);
-		attr = parse_symbol_attr(parse);
-		list_append(&symbol->attr, attr);
-	}
+	parse_symbol_attrs(parse, symbol);
 
 	lmatch(parse, lc_scolon);
+
+	switch (outer_csi->cc) {
+	case csi_class:
+	case csi_struct:
+		break;
+	case csi_interface:
+		cspan_print(deleg->name->cspan);
+		printf(" Error: Delegate declared inside interface.\n");
+		parse_note_error(parse);
+		/* XXX Free deleg */
+		return NULL;
+	}
 
 	return deleg;
@@ -491,5 +559,5 @@
 	stree_fun_t *fun;
 	stree_symbol_t *symbol;
-	stree_symbol_attr_t *attr;
+	bool_t body_expected;
 
 	fun = stree_fun_new();
@@ -508,12 +576,9 @@
 	fun->sig = parse_fun_sig(parse);
 
-	list_init(&symbol->attr);
-
 	/* Parse attributes. */
-	while (lcur_lc(parse) == lc_comma && !parse_is_error(parse)) {
-		lskip(parse);
-		attr = parse_symbol_attr(parse);
-		list_append(&symbol->attr, attr);
-	}
+	parse_symbol_attrs(parse, symbol);
+
+	body_expected = !stree_symbol_has_attr(symbol, sac_builtin) &&
+	    (outer_csi->cc != csi_interface);
 
 	fun->proc = stree_proc_new();
@@ -523,11 +588,13 @@
 		lskip(parse);
 
-		/* This function has no body. */
-		if (!stree_symbol_has_attr(symbol, sac_builtin)) {
-			printf("Error: Function '");
+		/* Body not present */
+		if (body_expected) {
+			cspan_print(fun->name->cspan);
+			printf(" Error: Function '");
 			symbol_print_fqn(symbol);
-			printf("' has no body.\n");
+			printf("' should have a body.\n");
 			parse_note_error(parse);
 		}
+
 		fun->proc->body = NULL;
 	} else {
@@ -535,4 +602,13 @@
 		fun->proc->body = parse_block(parse);
 		lmatch(parse, lc_end);
+
+		/* Body present */
+		if (!body_expected) {
+			cspan_print(fun->name->cspan);
+			printf(" Error: Function declaration '");
+			symbol_print_fqn(symbol);
+			printf("' should not have a body.\n");
+			parse_note_error(parse);
+		}
 	}
 
@@ -561,5 +637,20 @@
 	lmatch(parse, lc_colon);
 	var->type =  parse_texpr(parse);
+
+	parse_symbol_attrs(parse, symbol);
+
 	lmatch(parse, lc_scolon);
+
+	switch (outer_csi->cc) {
+	case csi_class:
+	case csi_struct:
+		break;
+	case csi_interface:
+		cspan_print(var->name->cspan);
+		printf(" Error: Variable declared inside interface.\n");
+		parse_note_error(parse);
+		/* XXX Free var */
+		return NULL;
+	}
 
 	return var;
@@ -576,4 +667,5 @@
 	stree_prop_t *prop;
 	stree_symbol_t *symbol;
+	bool_t body_expected;
 
 	stree_ident_t *ident;
@@ -625,4 +717,10 @@
 	lmatch(parse, lc_colon);
 	prop->type = parse_texpr(parse);
+
+	/* Parse attributes. */
+	parse_symbol_attrs(parse, symbol);
+
+	body_expected = (outer_csi->cc != csi_interface);
+
 	lmatch(parse, lc_is);
 
@@ -630,40 +728,8 @@
 		switch (lcur_lc(parse)) {
 		case lc_get:
-			lskip(parse);
-			lmatch(parse, lc_is);
-			if (prop->getter != NULL) {
-				printf("Error: Duplicate getter.\n");
-				(void) parse_block(parse); /* XXX Free */
-				lmatch(parse, lc_end);
-				parse_note_error(parse);
-				break;
-			}
-
-			/* Create setter procedure */
-			prop->getter = stree_proc_new();
-			prop->getter->body = parse_block(parse);
-			prop->getter->outer_symbol = symbol;
-
-			lmatch(parse, lc_end);
+			parse_prop_get(parse, prop);
 			break;
 		case lc_set:
-			lskip(parse);
-			prop->setter_arg = stree_proc_arg_new();
-			prop->setter_arg->name = parse_ident(parse);
-			prop->setter_arg->type = prop->type;
-			lmatch(parse, lc_is);
-			if (prop->setter != NULL) {
-				printf("Error: Duplicate setter.\n");
-				(void) parse_block(parse); /* XXX Free */
-				lmatch(parse, lc_end);
-				parse_note_error(parse);
-			}
-
-			/* Create setter procedure */
-			prop->setter = stree_proc_new();
-			prop->setter->body = parse_block(parse);
-			prop->setter->outer_symbol = symbol;
-
-			lmatch(parse, lc_end);
+			parse_prop_set(parse, prop);
 			break;
 		default:
@@ -677,24 +743,51 @@
 }
 
+/** Parse symbol attributes.
+ *
+ * Parse list of attributes and add them to @a symbol.
+ *
+ * @param parse		Parser object
+ * @param symbol	Symbol to add these attributes to
+ */
+static void parse_symbol_attrs(parse_t *parse, stree_symbol_t *symbol)
+{
+	stree_symbol_attr_t *attr;
+
+	/* Parse attributes. */
+	while (lcur_lc(parse) == lc_comma && !parse_is_error(parse)) {
+		lskip(parse);
+		attr = parse_symbol_attr(parse);
+		list_append(&symbol->attr, attr);
+	}
+}
+
 /** Parse symbol attribute.
  *
- * @param parse		Parser object.
- * @param outer_csi	CSI containing this declaration or @c NULL if global.
- * @return		New syntax tree node.
+ * @param parse		Parser object
+ * @return		New syntax tree node
  */
 static stree_symbol_attr_t *parse_symbol_attr(parse_t *parse)
 {
 	stree_symbol_attr_t *attr;
-
-	if (lcur_lc(parse) != lc_builtin) {
-		printf("Error: Unexpected attribute '");
+	symbol_attr_class_t sac;
+
+	/* Make compiler happy. */
+	sac = 0;
+
+	switch (lcur_lc(parse)) {
+	case lc_builtin: sac = sac_builtin; break;
+	case lc_static: sac = sac_static; break;
+	default:
+		cspan_print(lcur_span(parse));
+		printf(" Error: Unexpected attribute '");
 		lem_print(lcur(parse));
 		printf("'.\n");
 		parse_note_error(parse);
+		break;
 	}
 
 	lskip(parse);
 
-	attr = stree_symbol_attr_new(sac_builtin);
+	attr = stree_symbol_attr_new(sac);
 	return attr;
 }
@@ -718,5 +811,5 @@
 	printf("Parse procedure argument.\n");
 #endif
- 	list_init(&arg->attr);
+	list_init(&arg->attr);
 
 	/* Parse attributes. */
@@ -740,5 +833,6 @@
 
 	if (lcur_lc(parse) != lc_packed) {
-		printf("Error: Unexpected attribute '");
+		cspan_print(lcur_span(parse));
+		printf(" Error: Unexpected attribute '");
 		lem_print(lcur(parse));
 		printf("'.\n");
@@ -802,4 +896,138 @@
 
 	return sig;
+}
+
+/** Parse member property getter.
+ *
+ * @param parse		Parser object.
+ * @param prop		Property containing this declaration.
+ */
+static void parse_prop_get(parse_t *parse, stree_prop_t *prop)
+{
+	cspan_t *cspan;
+	stree_block_t *block;
+	stree_proc_t *getter;
+	bool_t body_expected;
+
+	body_expected = (prop->symbol->outer_csi->cc != csi_interface);
+
+	lskip(parse);
+	cspan = lprev_span(parse);
+
+	if (prop->getter != NULL) {
+		cspan_print(cspan);
+		printf(" Error: Duplicate getter.\n");
+		parse_note_error(parse);
+		return;
+	}
+
+	if (lcur_lc(parse) == lc_scolon) {
+		/* Body not present */
+		lskip(parse);
+		block = NULL;
+
+		if (body_expected) {
+			cspan_print(prop->name->cspan);
+			printf(" Error: Property '");
+			symbol_print_fqn(prop->symbol);
+			printf("' getter should have "
+			    "a body.\n");
+			parse_note_error(parse);
+		}
+	} else {
+		/* Body present */
+		lmatch(parse, lc_is);
+		block = parse_block(parse);
+		lmatch(parse, lc_end);
+
+		if (!body_expected) {
+			cspan_print(prop->name->cspan);
+			printf(" Error: Property '");
+			symbol_print_fqn(prop->symbol);
+			printf("' getter declaration should "
+			    "not have a body.\n");
+			parse_note_error(parse);
+
+			/* XXX Free block */
+			block = NULL;
+		}
+	}
+
+	/* Create getter procedure */
+	getter = stree_proc_new();
+	getter->body = block;
+	getter->outer_symbol = prop->symbol;
+
+	/* Store getter in property. */
+	prop->getter = getter;
+}
+
+
+/** Parse member property setter.
+ *
+ * @param parse		Parser object.
+ * @param prop		Property containing this declaration.
+ */
+static void parse_prop_set(parse_t *parse, stree_prop_t *prop)
+{
+	cspan_t *cspan;
+	stree_block_t *block;
+	stree_proc_t *setter;
+	bool_t body_expected;
+
+	body_expected = (prop->symbol->outer_csi->cc != csi_interface);
+
+	lskip(parse);
+	cspan = lprev_span(parse);
+
+	if (prop->setter != NULL) {
+		cspan_print(cspan);
+		printf(" Error: Duplicate setter.\n");
+		parse_note_error(parse);
+		return;
+	}
+
+	prop->setter_arg = stree_proc_arg_new();
+	prop->setter_arg->name = parse_ident(parse);
+	prop->setter_arg->type = prop->type;
+
+	if (lcur_lc(parse) == lc_scolon) {
+		/* Body not present */
+		lskip(parse);
+
+		block = NULL;
+
+		if (body_expected) {
+			cspan_print(prop->name->cspan);
+			printf(" Error: Property '");
+			symbol_print_fqn(prop->symbol);
+			printf("' setter should have "
+			    "a body.\n");
+			parse_note_error(parse);
+		}
+	} else {
+		/* Body present */
+		lmatch(parse, lc_is);
+		block = parse_block(parse);
+		lmatch(parse, lc_end);
+
+		if (!body_expected) {
+			cspan_print(prop->name->cspan);
+			printf(" Error: Property '");
+			symbol_print_fqn(prop->symbol);
+			printf("' setter declaration should "
+			    "not have a body.\n");
+			parse_note_error(parse);
+		}
+	}
+
+
+	/* Create setter procedure */
+	setter = stree_proc_new();
+	setter->body = block;
+	setter->outer_symbol = prop->symbol;
+
+	/* Store setter in property. */
+	prop->setter = setter;
 }
 
Index: uspace/app/sbi/src/program.c
===================================================================
--- uspace/app/sbi/src/program.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/program.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -85,4 +85,9 @@
  * is read from '<libdir>/libflist'. Each line of the file contains one file
  * name relative to <libdir>.
+ *
+ * @param program 	The program to which the parsed code is added.
+ * @return		EOK on success, EIO if some file comprising the
+ *			library is not found, EINVAL if the library
+ *			has syntax errors.
  */
 int program_lib_process(stree_program_t *program)
@@ -147,4 +152,4 @@
 	fclose(f);
 
-	return rc;
+	return EOK;
 }
Index: uspace/app/sbi/src/rdata.c
===================================================================
--- uspace/app/sbi/src/rdata.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/rdata.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -609,5 +609,5 @@
 	(void) src; (void) dest;
 	printf("Unimplemented: Copy object.\n");
-	exit(1);
+	abort();
 }
 
Index: uspace/app/sbi/src/rdata_t.h
===================================================================
--- uspace/app/sbi/src/rdata_t.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/rdata_t.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -71,9 +71,9 @@
  *
  * A delegate variable points to a static or non-static symbol. If the
- * symbol is non static, @c obj points to the object the symbol instance
+ * symbol is non static, @c obj points to the object the symbol
  * belongs to.
  */
 typedef struct {
-	/** Object or @c NULL if deleg. points to a CSI or static member. */
+	/** Object or @c NULL if deleg. points to a static function. */
 	struct rdata_var *obj;
 
@@ -107,4 +107,7 @@
 	/** Class of this object (symbol) */
 	struct stree_symbol *class_sym;
+
+	/** @c sn_static if this is a static object (i.e. class object) */
+	statns_t static_obj;
 
 	/** Map field name SID to field data */
Index: uspace/app/sbi/src/run.c
===================================================================
--- uspace/app/sbi/src/run.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/run.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -99,4 +99,5 @@
 	stree_symbol_t *main_fun_sym;
 	stree_fun_t *main_fun;
+	rdata_var_t *main_obj;
 	stree_ident_t *fake_ident;
 	list_t main_args;
@@ -111,4 +112,7 @@
 	list_init(&run->thread_ar->proc_ar);
 	run->thread_ar->bo_mode = bm_none;
+
+	/* Initialize global data structure. */
+	run_gdata_init(run);
 
 	/*
@@ -126,4 +130,6 @@
 	assert(main_fun != NULL);
 
+	main_obj = run_fun_sobject_find(run, main_fun);
+
 #ifdef DEBUG_RUN_TRACE
 	printf("Found function '"); symbol_print_fqn(main_fun_sym);
@@ -133,9 +139,26 @@
 	/* Run function @c main. */
 	list_init(&main_args);
-	run_proc_ar_create(run, NULL, main_fun->proc, &proc_ar);
+	run_proc_ar_create(run, main_obj, main_fun->proc, &proc_ar);
 	run_proc_ar_set_args(run, proc_ar, &main_args);
 	run_proc(run, proc_ar, &res);
 
 	run_exc_check_unhandled(run);
+}
+
+/** Initialize global data.
+ *
+ * @param run		Runner object
+ */
+void run_gdata_init(run_t *run)
+{
+	rdata_object_t *gobject;
+
+	run->gdata = rdata_var_new(vc_object);
+	gobject = rdata_object_new();
+	run->gdata->u.object_v = gobject;
+
+	gobject->class_sym = NULL;
+	gobject->static_obj = sn_static;
+	intmap_init(&gobject->fields);
 }
 
@@ -787,4 +810,102 @@
 	proc_ar = run_get_current_proc_ar(run);
 	return proc_ar->proc->outer_symbol->outer_csi;
+}
+
+/** Get static object (i.e. class object).
+ *
+ * Looks for a child static object named @a name in static object @a pobject.
+ * If the child does not exist yet, it is created.
+ *
+ * @param run		Runner object
+ * @param csi		CSI of the static object named @a name
+ * @param pobject	Parent static object
+ * @param name		Static object name
+ *
+ * @return		Static (class) object of the given name
+ */
+rdata_var_t *run_sobject_get(run_t *run, stree_csi_t *csi,
+    rdata_var_t *pobj_var, sid_t name)
+{
+	rdata_object_t *pobject;
+	rdata_var_t *mbr_var;
+	rdata_var_t *rvar;
+	stree_ident_t *ident;
+
+	assert(pobj_var->vc == vc_object);
+	pobject = pobj_var->u.object_v;
+#ifdef DEBUG_RUN_TRACE
+	printf("Get static object '%s' in '", strtab_get_str(name));
+	if (pobject->class_sym != NULL)
+		symbol_print_fqn(pobject->class_sym);
+	else
+		printf("global");
+#endif
+
+	assert(pobject->static_obj == sn_static);
+
+	mbr_var = intmap_get(&pobject->fields, name);
+	if (mbr_var != NULL) {
+#ifdef DEBUG_RUN_TRACE
+		printf("Return exising static object (mbr_var=%p).\n", mbr_var);
+#endif
+		/* Return existing object. */
+		return mbr_var;
+	}
+
+	/* Construct new object. */
+#ifdef DEBUG_RUN_TRACE
+	printf("Construct new static object.\n");
+#endif
+	ident = stree_ident_new();
+	ident->sid = name;
+
+	run_new_csi_inst(run, csi, sn_static, &rvar);
+
+	/* Store static object reference for future use. */
+	intmap_set(&pobject->fields, name, rvar);
+
+	return rvar;
+}
+
+/** Get static object for CSI.
+ *
+ * In situations where we do not have the parent static object and need
+ * to find static object for a CSI from the gdata root we use this.
+ *
+ * This is only used in special cases such as when invoking the entry
+ * point. This is too slow to use during normal execution.
+ *
+ * @param run		Runner object
+ * @param csi		CSI to get static object of
+ *
+ * @return		Static (class) object
+ */
+rdata_var_t *run_sobject_find(run_t *run, stree_csi_t *csi)
+{
+	rdata_var_t *pobj_var;
+
+	if (csi == NULL)
+		return run->gdata;
+
+	assert(csi->ancr_state == ws_visited);
+	pobj_var = run_sobject_find(run, csi_to_symbol(csi)->outer_csi);
+
+	return run_sobject_get(run, csi, pobj_var, csi->name->sid);
+}
+
+/** Get static object for CSI containing function.
+ *
+ * This is used to obtain active object for invoking static function
+ * @a fun. Only used in cases where we don't already have the object such
+ * as when running the entry point. Otherwise this would be slow.
+ *
+ * @param run		Runner object
+ * @param fun		Function to get static class object of
+ *
+ * @return		Static (class) object
+ */
+rdata_var_t *run_fun_sobject_find(run_t *run, stree_fun_t *fun)
+{
+	return run_sobject_find(run, fun_to_symbol(fun)->outer_csi);
 }
 
@@ -1512,5 +1633,5 @@
 
 	/* Create exception object. */
-	run_new_csi_inst(run, csi, &exc_vi);
+	run_new_csi_inst_ref(run, csi, sn_nonstatic, &exc_vi);
 	assert(exc_vi->ic == ic_value);
 
Index: uspace/app/sbi/src/run.h
===================================================================
--- uspace/app/sbi/src/run.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/run.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -33,4 +33,5 @@
 
 void run_init(run_t *run);
+void run_gdata_init(run_t *run);
 void run_program(run_t *run, stree_program_t *prog);
 void run_proc(run_t *run, run_proc_ar_t *proc_ar, rdata_item_t **res);
@@ -47,4 +48,9 @@
 run_block_ar_t *run_get_current_block_ar(run_t *run);
 stree_csi_t *run_get_current_csi(run_t *run);
+
+rdata_var_t *run_sobject_get(run_t *run, stree_csi_t *pcsi,
+    rdata_var_t *pobj_var, sid_t name);
+rdata_var_t *run_sobject_find(run_t *run, stree_csi_t *csi);
+rdata_var_t *run_fun_sobject_find(run_t *run, stree_fun_t *fun);
 
 void run_value_item_to_var(rdata_item_t *item, rdata_var_t **var);
